/***** pamPower.c *********************************
 * Description: 
 * Author: Bernhard Haubold, haubold@evolbio.mpg.de
 * Date: Tue Jan  6 11:53:01 2015
 **************************************************/
#include <stdio.h>
#include <stdlib.h>
#include "interface.h"
#include "eprintf.h"
#include "pam.h"

void scanFile(FILE *fp, Args *args);

int main(int argc, char *argv[]){
  int i;
  char *version;
  Args *args;
  FILE *fp;

  version = "0.7";
  setprogname2("pamPower");
  args = getArgs(argc, argv);
  if(args->v)
    printSplash(version);
  if(args->h || args->e)
    printUsage(version);
  if(args->numInputFiles == 0){
    fp = stdin;
    scanFile(fp, args);
  }else{
    for(i=0;i<args->numInputFiles;i++){
      fp = efopen(args->inputFiles[i],"r");
      scanFile(fp, args);
      fclose(fp);
    }
  }
  free(args);
  free(progname());
  return 0;
}

void scanFile(FILE *fp, Args *args){
  int i;
  SubstitutionMatrix *matA, *matB;

  matA = readSubstitutionMatrix(fp);
  matB = duplicateSubstitutionMatrix(matA);
  /* matrix multiplication */
  for(i=1;i<args->n;i++)
    matA = matrixMult(matA, matB);
  outputMatrix(stdout,matA,args->f);
}
